

Drupal.gmaps_faceted_ajax_search = Drupal.gmaps_faceted_ajax_search || {};


/**
 * Event handler when search results and new serch blocks come back.
 */
Drupal.gmaps_faceted_ajax_search.ajax_success_event = function(result) {
  for (var region in result.regions) {
    $('#gmaps_faceted_ajax_search_wrapper_' + region).hide();
    $('#gmaps_faceted_ajax_search_wrapper_' + region).html(result.regions[region]);
    $('#gmaps_faceted_ajax_search_wrapper_' + region).fadeIn('slow');
    Drupal.attachBehaviors('#gmaps_faceted_ajax_search_wrapper_' + region);
  }
}

/**
 * Drupal behavior for gmaps_faceted_ajax_search module.
 *
 * Attach ajax events for the selected search region.
 * Display results in the selected result region.
 */
Drupal.behaviors.gmaps_faceted_ajax_search = function(context) {
  $('.block-faceted_search_ui a:not(.gmaps-faceted-ajax-search-processed)', context).each(function(index, a){
    $(a).click(function(){
      var href = $(a).attr('href');
      // If link doesn not contain the word: results, it means it points to the
      // faceted starter page.
      if (href.toString().match(/results/gi)) {
        $('.block-faceted_search_ui').append('<div class="gmaps_faceted_ajax_search_indicator"></div>');
        Drupal.gmaps.loadAjaxContent({
          type: 'POST',
          url: href,
          data: {gmaps_faceted_ajax_search: 1},
          dataType: 'json',
          success: Drupal.gmaps_faceted_ajax_search.ajax_success_event
        });
        return false;
      }
    }).addClass("gmaps-faceted-ajax-search-processed");
  });

  $('.block-faceted_search_ui form:not(.gmaps-faceted-ajax-search-processed)', context).submit(function(){
    $('.block-faceted_search_ui').append('<div class="gmaps_faceted_ajax_search_indicator"></div>');
    Drupal.gmaps.ajaxSubmit($(this), {
      type: 'POST',
      url: $(this).attr('action'),
      data: {gmaps_faceted_ajax_search: 1, gmaps_faceted_ajax_search_form: 1},
      dataType: 'json',
      success: Drupal.gmaps_faceted_ajax_search.ajax_success_event
    });
    return false;
  }).addClass("gmaps-faceted-ajax-search-processed");
}

